# encoding: utf-8

module Mysqlcollector
  class Log
    def initialize
      @log = Logger.new(STDOUT)
    end

    def valid?(command)
      return false if command.nil?
      return false if command.empty?
      return false unless command.is_a?(String)
      true
    end

    def debug(command)
      return false unless valid?(command)

      @log.debug("#{command}") if $config[:debug]
    end

    def error(error)
      return false unless valid?(error)

      @log.error(error)
      exit 1
    end

    def sql_error(error, sql)
      return false unless valid?(error)
      return false unless valid?(sql)

      @log.error("MySQL Error: #{error}")
      @log.error("MySQL SQL Statement: #{sql}")
      exit 1
    end
  end
end
