# encoding: utf-8

module Mysqlcollector
  class Mysql
    def initialize
      @conn = Mysql2::Client.new(host: $config[:mysql_host],
                                 port: $config[:mysql_port],
                                 username: $config[:mysql_username],
                                 password: $config[:mysql_password])

      Mysqlcollector::Log.new.debug("Connected on MySQL server: #{$config[:mysql_host]}:#{$config[:mysql_port]}");
    rescue Exception => error
      Mysqlcollector::Log.new.error(error.message)
    end

    def execute(sql)
      begin
        Mysqlcollector::Log.new.debug("MySQL Query: #{sql}")

        @conn.query(sql).each(:as => :hash)
      rescue Exception => error
        Mysqlcollector::Log.new.sql_error(error, sql);
      end
    end

    def close
      @conn.close
    rescue
      exit 1
    end
  end
end
